// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from robot_calibration_msgs:msg/CaptureConfig.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "robot_calibration_msgs/msg/capture_config.hpp"


#ifndef ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CAPTURE_CONFIG__STRUCT_HPP_
#define ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CAPTURE_CONFIG__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


// Include directives for member types
// Member 'joint_states'
#include "sensor_msgs/msg/detail/joint_state__struct.hpp"

#ifndef _WIN32
# define DEPRECATED__robot_calibration_msgs__msg__CaptureConfig __attribute__((deprecated))
#else
# define DEPRECATED__robot_calibration_msgs__msg__CaptureConfig __declspec(deprecated)
#endif

namespace robot_calibration_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CaptureConfig_
{
  using Type = CaptureConfig_<ContainerAllocator>;

  explicit CaptureConfig_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : joint_states(_init)
  {
    (void)_init;
  }

  explicit CaptureConfig_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : joint_states(_alloc, _init)
  {
    (void)_init;
  }

  // field types and members
  using _joint_states_type =
    sensor_msgs::msg::JointState_<ContainerAllocator>;
  _joint_states_type joint_states;
  using _features_type =
    std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>>;
  _features_type features;

  // setters for named parameter idiom
  Type & set__joint_states(
    const sensor_msgs::msg::JointState_<ContainerAllocator> & _arg)
  {
    this->joint_states = _arg;
    return *this;
  }
  Type & set__features(
    const std::vector<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>>> & _arg)
  {
    this->features = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    robot_calibration_msgs::msg::CaptureConfig_<ContainerAllocator> *;
  using ConstRawPtr =
    const robot_calibration_msgs::msg::CaptureConfig_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<robot_calibration_msgs::msg::CaptureConfig_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<robot_calibration_msgs::msg::CaptureConfig_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      robot_calibration_msgs::msg::CaptureConfig_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<robot_calibration_msgs::msg::CaptureConfig_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      robot_calibration_msgs::msg::CaptureConfig_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<robot_calibration_msgs::msg::CaptureConfig_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<robot_calibration_msgs::msg::CaptureConfig_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<robot_calibration_msgs::msg::CaptureConfig_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__robot_calibration_msgs__msg__CaptureConfig
    std::shared_ptr<robot_calibration_msgs::msg::CaptureConfig_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__robot_calibration_msgs__msg__CaptureConfig
    std::shared_ptr<robot_calibration_msgs::msg::CaptureConfig_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CaptureConfig_ & other) const
  {
    if (this->joint_states != other.joint_states) {
      return false;
    }
    if (this->features != other.features) {
      return false;
    }
    return true;
  }
  bool operator!=(const CaptureConfig_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CaptureConfig_

// alias to use template instance with default allocator
using CaptureConfig =
  robot_calibration_msgs::msg::CaptureConfig_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace robot_calibration_msgs

#endif  // ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CAPTURE_CONFIG__STRUCT_HPP_
