// generated from rosidl_typesupport_introspection_cpp/resource/idl__type_support.cpp.em
// with input from robot_calibration_msgs:msg/ExtendedCameraInfo.idl
// generated code does not contain a copyright notice

#include "array"
#include "cstddef"
#include "string"
#include "vector"
#include "rosidl_runtime_c/message_type_support_struct.h"
#include "rosidl_typesupport_cpp/message_type_support.hpp"
#include "rosidl_typesupport_interface/macros.h"
#include "robot_calibration_msgs/msg/detail/extended_camera_info__functions.h"
#include "robot_calibration_msgs/msg/detail/extended_camera_info__struct.hpp"
#include "rosidl_typesupport_introspection_cpp/field_types.hpp"
#include "rosidl_typesupport_introspection_cpp/identifier.hpp"
#include "rosidl_typesupport_introspection_cpp/message_introspection.hpp"
#include "rosidl_typesupport_introspection_cpp/message_type_support_decl.hpp"
#include "rosidl_typesupport_introspection_cpp/visibility_control.h"

namespace robot_calibration_msgs
{

namespace msg
{

namespace rosidl_typesupport_introspection_cpp
{

void ExtendedCameraInfo_init_function(
  void * message_memory, rosidl_runtime_cpp::MessageInitialization _init)
{
  new (message_memory) robot_calibration_msgs::msg::ExtendedCameraInfo(_init);
}

void ExtendedCameraInfo_fini_function(void * message_memory)
{
  auto typed_message = static_cast<robot_calibration_msgs::msg::ExtendedCameraInfo *>(message_memory);
  typed_message->~ExtendedCameraInfo();
}

size_t size_function__ExtendedCameraInfo__parameters(const void * untyped_member)
{
  const auto * member = reinterpret_cast<const std::vector<robot_calibration_msgs::msg::CameraParameter> *>(untyped_member);
  return member->size();
}

const void * get_const_function__ExtendedCameraInfo__parameters(const void * untyped_member, size_t index)
{
  const auto & member =
    *reinterpret_cast<const std::vector<robot_calibration_msgs::msg::CameraParameter> *>(untyped_member);
  return &member[index];
}

void * get_function__ExtendedCameraInfo__parameters(void * untyped_member, size_t index)
{
  auto & member =
    *reinterpret_cast<std::vector<robot_calibration_msgs::msg::CameraParameter> *>(untyped_member);
  return &member[index];
}

void fetch_function__ExtendedCameraInfo__parameters(
  const void * untyped_member, size_t index, void * untyped_value)
{
  const auto & item = *reinterpret_cast<const robot_calibration_msgs::msg::CameraParameter *>(
    get_const_function__ExtendedCameraInfo__parameters(untyped_member, index));
  auto & value = *reinterpret_cast<robot_calibration_msgs::msg::CameraParameter *>(untyped_value);
  value = item;
}

void assign_function__ExtendedCameraInfo__parameters(
  void * untyped_member, size_t index, const void * untyped_value)
{
  auto & item = *reinterpret_cast<robot_calibration_msgs::msg::CameraParameter *>(
    get_function__ExtendedCameraInfo__parameters(untyped_member, index));
  const auto & value = *reinterpret_cast<const robot_calibration_msgs::msg::CameraParameter *>(untyped_value);
  item = value;
}

void resize_function__ExtendedCameraInfo__parameters(void * untyped_member, size_t size)
{
  auto * member =
    reinterpret_cast<std::vector<robot_calibration_msgs::msg::CameraParameter> *>(untyped_member);
  member->resize(size);
}

static const ::rosidl_typesupport_introspection_cpp::MessageMember ExtendedCameraInfo_message_member_array[2] = {
  {
    "camera_info",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<sensor_msgs::msg::CameraInfo>(),  // members of sub message
    false,  // is key
    false,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(robot_calibration_msgs::msg::ExtendedCameraInfo, camera_info),  // bytes offset in struct
    nullptr,  // default value
    nullptr,  // size() function pointer
    nullptr,  // get_const(index) function pointer
    nullptr,  // get(index) function pointer
    nullptr,  // fetch(index, &value) function pointer
    nullptr,  // assign(index, value) function pointer
    nullptr  // resize(index) function pointer
  },
  {
    "parameters",  // name
    ::rosidl_typesupport_introspection_cpp::ROS_TYPE_MESSAGE,  // type
    0,  // upper bound of string
    ::rosidl_typesupport_introspection_cpp::get_message_type_support_handle<robot_calibration_msgs::msg::CameraParameter>(),  // members of sub message
    false,  // is key
    true,  // is array
    0,  // array size
    false,  // is upper bound
    offsetof(robot_calibration_msgs::msg::ExtendedCameraInfo, parameters),  // bytes offset in struct
    nullptr,  // default value
    size_function__ExtendedCameraInfo__parameters,  // size() function pointer
    get_const_function__ExtendedCameraInfo__parameters,  // get_const(index) function pointer
    get_function__ExtendedCameraInfo__parameters,  // get(index) function pointer
    fetch_function__ExtendedCameraInfo__parameters,  // fetch(index, &value) function pointer
    assign_function__ExtendedCameraInfo__parameters,  // assign(index, value) function pointer
    resize_function__ExtendedCameraInfo__parameters  // resize(index) function pointer
  }
};

static const ::rosidl_typesupport_introspection_cpp::MessageMembers ExtendedCameraInfo_message_members = {
  "robot_calibration_msgs::msg",  // message namespace
  "ExtendedCameraInfo",  // message name
  2,  // number of fields
  sizeof(robot_calibration_msgs::msg::ExtendedCameraInfo),
  false,  // has_any_key_member_
  ExtendedCameraInfo_message_member_array,  // message members
  ExtendedCameraInfo_init_function,  // function to initialize message memory (memory has to be allocated)
  ExtendedCameraInfo_fini_function  // function to terminate message instance (will not free memory)
};

static const rosidl_message_type_support_t ExtendedCameraInfo_message_type_support_handle = {
  ::rosidl_typesupport_introspection_cpp::typesupport_identifier,
  &ExtendedCameraInfo_message_members,
  get_message_typesupport_handle_function,
  &robot_calibration_msgs__msg__ExtendedCameraInfo__get_type_hash,
  &robot_calibration_msgs__msg__ExtendedCameraInfo__get_type_description,
  &robot_calibration_msgs__msg__ExtendedCameraInfo__get_type_description_sources,
};

}  // namespace rosidl_typesupport_introspection_cpp

}  // namespace msg

}  // namespace robot_calibration_msgs


namespace rosidl_typesupport_introspection_cpp
{

template<>
ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
get_message_type_support_handle<robot_calibration_msgs::msg::ExtendedCameraInfo>()
{
  return &::robot_calibration_msgs::msg::rosidl_typesupport_introspection_cpp::ExtendedCameraInfo_message_type_support_handle;
}

}  // namespace rosidl_typesupport_introspection_cpp

#ifdef __cplusplus
extern "C"
{
#endif

ROSIDL_TYPESUPPORT_INTROSPECTION_CPP_PUBLIC
const rosidl_message_type_support_t *
ROSIDL_TYPESUPPORT_INTERFACE__MESSAGE_SYMBOL_NAME(rosidl_typesupport_introspection_cpp, robot_calibration_msgs, msg, ExtendedCameraInfo)() {
  return &::robot_calibration_msgs::msg::rosidl_typesupport_introspection_cpp::ExtendedCameraInfo_message_type_support_handle;
}

#ifdef __cplusplus
}
#endif
