// generated from rosidl_generator_c/resource/idl__struct.h.em
// with input from robot_calibration_msgs:msg/CalibrationData.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "robot_calibration_msgs/msg/calibration_data.h"


#ifndef ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CALIBRATION_DATA__STRUCT_H_
#define ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CALIBRATION_DATA__STRUCT_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stddef.h>
#include <stdint.h>

// Constants defined in the message

// Include directives for member types
// Member 'joint_states'
#include "sensor_msgs/msg/detail/joint_state__struct.h"
// Member 'observations'
#include "robot_calibration_msgs/msg/detail/observation__struct.h"

/// Struct defined in msg/CalibrationData in the package robot_calibration_msgs.
/**
  * State of the robot when this data was collected
 */
typedef struct robot_calibration_msgs__msg__CalibrationData
{
  sensor_msgs__msg__JointState joint_states;
  /// Observations, one entry per sensor that is collecting data
  robot_calibration_msgs__msg__Observation__Sequence observations;
} robot_calibration_msgs__msg__CalibrationData;

// Struct for a sequence of robot_calibration_msgs__msg__CalibrationData.
typedef struct robot_calibration_msgs__msg__CalibrationData__Sequence
{
  robot_calibration_msgs__msg__CalibrationData * data;
  /// The number of valid items in data
  size_t size;
  /// The number of allocated items in data
  size_t capacity;
} robot_calibration_msgs__msg__CalibrationData__Sequence;

#ifdef __cplusplus
}
#endif

#endif  // ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CALIBRATION_DATA__STRUCT_H_
