// generated from rosidl_generator_cpp/resource/idl__struct.hpp.em
// with input from robot_calibration_msgs:msg/CameraParameter.idl
// generated code does not contain a copyright notice

// IWYU pragma: private, include "robot_calibration_msgs/msg/camera_parameter.hpp"


#ifndef ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CAMERA_PARAMETER__STRUCT_HPP_
#define ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CAMERA_PARAMETER__STRUCT_HPP_

#include <algorithm>
#include <array>
#include <memory>
#include <string>
#include <vector>

#include "rosidl_runtime_cpp/bounded_vector.hpp"
#include "rosidl_runtime_cpp/message_initialization.hpp"


#ifndef _WIN32
# define DEPRECATED__robot_calibration_msgs__msg__CameraParameter __attribute__((deprecated))
#else
# define DEPRECATED__robot_calibration_msgs__msg__CameraParameter __declspec(deprecated)
#endif

namespace robot_calibration_msgs
{

namespace msg
{

// message struct
template<class ContainerAllocator>
struct CameraParameter_
{
  using Type = CameraParameter_<ContainerAllocator>;

  explicit CameraParameter_(rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->value = 0.0;
    }
  }

  explicit CameraParameter_(const ContainerAllocator & _alloc, rosidl_runtime_cpp::MessageInitialization _init = rosidl_runtime_cpp::MessageInitialization::ALL)
  : name(_alloc)
  {
    if (rosidl_runtime_cpp::MessageInitialization::ALL == _init ||
      rosidl_runtime_cpp::MessageInitialization::ZERO == _init)
    {
      this->name = "";
      this->value = 0.0;
    }
  }

  // field types and members
  using _name_type =
    std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>>;
  _name_type name;
  using _value_type =
    double;
  _value_type value;

  // setters for named parameter idiom
  Type & set__name(
    const std::basic_string<char, std::char_traits<char>, typename std::allocator_traits<ContainerAllocator>::template rebind_alloc<char>> & _arg)
  {
    this->name = _arg;
    return *this;
  }
  Type & set__value(
    const double & _arg)
  {
    this->value = _arg;
    return *this;
  }

  // constant declarations

  // pointer types
  using RawPtr =
    robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator> *;
  using ConstRawPtr =
    const robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator> *;
  using SharedPtr =
    std::shared_ptr<robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator>>;
  using ConstSharedPtr =
    std::shared_ptr<robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator> const>;

  template<typename Deleter = std::default_delete<
      robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator>>>
  using UniquePtrWithDeleter =
    std::unique_ptr<robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator>, Deleter>;

  using UniquePtr = UniquePtrWithDeleter<>;

  template<typename Deleter = std::default_delete<
      robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator>>>
  using ConstUniquePtrWithDeleter =
    std::unique_ptr<robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator> const, Deleter>;
  using ConstUniquePtr = ConstUniquePtrWithDeleter<>;

  using WeakPtr =
    std::weak_ptr<robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator>>;
  using ConstWeakPtr =
    std::weak_ptr<robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator> const>;

  // pointer types similar to ROS 1, use SharedPtr / ConstSharedPtr instead
  // NOTE: Can't use 'using' here because GNU C++ can't parse attributes properly
  typedef DEPRECATED__robot_calibration_msgs__msg__CameraParameter
    std::shared_ptr<robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator>>
    Ptr;
  typedef DEPRECATED__robot_calibration_msgs__msg__CameraParameter
    std::shared_ptr<robot_calibration_msgs::msg::CameraParameter_<ContainerAllocator> const>
    ConstPtr;

  // comparison operators
  bool operator==(const CameraParameter_ & other) const
  {
    if (this->name != other.name) {
      return false;
    }
    if (this->value != other.value) {
      return false;
    }
    return true;
  }
  bool operator!=(const CameraParameter_ & other) const
  {
    return !this->operator==(other);
  }
};  // struct CameraParameter_

// alias to use template instance with default allocator
using CameraParameter =
  robot_calibration_msgs::msg::CameraParameter_<std::allocator<void>>;

// constant definitions

}  // namespace msg

}  // namespace robot_calibration_msgs

#endif  // ROBOT_CALIBRATION_MSGS__MSG__DETAIL__CAMERA_PARAMETER__STRUCT_HPP_
