// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from robot_calibration_msgs:msg/Observation.idl
// generated code does not contain a copyright notice
#include "robot_calibration_msgs/msg/detail/observation__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>

#include "rcutils/allocator.h"


// Include directives for member types
// Member `sensor_name`
#include "rosidl_runtime_c/string_functions.h"
// Member `features`
#include "geometry_msgs/msg/detail/point_stamped__functions.h"
// Member `ext_camera_info`
#include "robot_calibration_msgs/msg/detail/extended_camera_info__functions.h"
// Member `cloud`
#include "sensor_msgs/msg/detail/point_cloud2__functions.h"
// Member `image`
#include "sensor_msgs/msg/detail/image__functions.h"

bool
robot_calibration_msgs__msg__Observation__init(robot_calibration_msgs__msg__Observation * msg)
{
  if (!msg) {
    return false;
  }
  // sensor_name
  if (!rosidl_runtime_c__String__init(&msg->sensor_name)) {
    robot_calibration_msgs__msg__Observation__fini(msg);
    return false;
  }
  // features
  if (!geometry_msgs__msg__PointStamped__Sequence__init(&msg->features, 0)) {
    robot_calibration_msgs__msg__Observation__fini(msg);
    return false;
  }
  // ext_camera_info
  if (!robot_calibration_msgs__msg__ExtendedCameraInfo__init(&msg->ext_camera_info)) {
    robot_calibration_msgs__msg__Observation__fini(msg);
    return false;
  }
  // cloud
  if (!sensor_msgs__msg__PointCloud2__init(&msg->cloud)) {
    robot_calibration_msgs__msg__Observation__fini(msg);
    return false;
  }
  // image
  if (!sensor_msgs__msg__Image__init(&msg->image)) {
    robot_calibration_msgs__msg__Observation__fini(msg);
    return false;
  }
  return true;
}

void
robot_calibration_msgs__msg__Observation__fini(robot_calibration_msgs__msg__Observation * msg)
{
  if (!msg) {
    return;
  }
  // sensor_name
  rosidl_runtime_c__String__fini(&msg->sensor_name);
  // features
  geometry_msgs__msg__PointStamped__Sequence__fini(&msg->features);
  // ext_camera_info
  robot_calibration_msgs__msg__ExtendedCameraInfo__fini(&msg->ext_camera_info);
  // cloud
  sensor_msgs__msg__PointCloud2__fini(&msg->cloud);
  // image
  sensor_msgs__msg__Image__fini(&msg->image);
}

bool
robot_calibration_msgs__msg__Observation__are_equal(const robot_calibration_msgs__msg__Observation * lhs, const robot_calibration_msgs__msg__Observation * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  // sensor_name
  if (!rosidl_runtime_c__String__are_equal(
      &(lhs->sensor_name), &(rhs->sensor_name)))
  {
    return false;
  }
  // features
  if (!geometry_msgs__msg__PointStamped__Sequence__are_equal(
      &(lhs->features), &(rhs->features)))
  {
    return false;
  }
  // ext_camera_info
  if (!robot_calibration_msgs__msg__ExtendedCameraInfo__are_equal(
      &(lhs->ext_camera_info), &(rhs->ext_camera_info)))
  {
    return false;
  }
  // cloud
  if (!sensor_msgs__msg__PointCloud2__are_equal(
      &(lhs->cloud), &(rhs->cloud)))
  {
    return false;
  }
  // image
  if (!sensor_msgs__msg__Image__are_equal(
      &(lhs->image), &(rhs->image)))
  {
    return false;
  }
  return true;
}

bool
robot_calibration_msgs__msg__Observation__copy(
  const robot_calibration_msgs__msg__Observation * input,
  robot_calibration_msgs__msg__Observation * output)
{
  if (!input || !output) {
    return false;
  }
  // sensor_name
  if (!rosidl_runtime_c__String__copy(
      &(input->sensor_name), &(output->sensor_name)))
  {
    return false;
  }
  // features
  if (!geometry_msgs__msg__PointStamped__Sequence__copy(
      &(input->features), &(output->features)))
  {
    return false;
  }
  // ext_camera_info
  if (!robot_calibration_msgs__msg__ExtendedCameraInfo__copy(
      &(input->ext_camera_info), &(output->ext_camera_info)))
  {
    return false;
  }
  // cloud
  if (!sensor_msgs__msg__PointCloud2__copy(
      &(input->cloud), &(output->cloud)))
  {
    return false;
  }
  // image
  if (!sensor_msgs__msg__Image__copy(
      &(input->image), &(output->image)))
  {
    return false;
  }
  return true;
}

robot_calibration_msgs__msg__Observation *
robot_calibration_msgs__msg__Observation__create(void)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  robot_calibration_msgs__msg__Observation * msg = (robot_calibration_msgs__msg__Observation *)allocator.allocate(sizeof(robot_calibration_msgs__msg__Observation), allocator.state);
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(robot_calibration_msgs__msg__Observation));
  bool success = robot_calibration_msgs__msg__Observation__init(msg);
  if (!success) {
    allocator.deallocate(msg, allocator.state);
    return NULL;
  }
  return msg;
}

void
robot_calibration_msgs__msg__Observation__destroy(robot_calibration_msgs__msg__Observation * msg)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (msg) {
    robot_calibration_msgs__msg__Observation__fini(msg);
  }
  allocator.deallocate(msg, allocator.state);
}


bool
robot_calibration_msgs__msg__Observation__Sequence__init(robot_calibration_msgs__msg__Observation__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  robot_calibration_msgs__msg__Observation * data = NULL;

  if (size) {
    data = (robot_calibration_msgs__msg__Observation *)allocator.zero_allocate(size, sizeof(robot_calibration_msgs__msg__Observation), allocator.state);
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = robot_calibration_msgs__msg__Observation__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        robot_calibration_msgs__msg__Observation__fini(&data[i - 1]);
      }
      allocator.deallocate(data, allocator.state);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
robot_calibration_msgs__msg__Observation__Sequence__fini(robot_calibration_msgs__msg__Observation__Sequence * array)
{
  if (!array) {
    return;
  }
  rcutils_allocator_t allocator = rcutils_get_default_allocator();

  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      robot_calibration_msgs__msg__Observation__fini(&array->data[i]);
    }
    allocator.deallocate(array->data, allocator.state);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

robot_calibration_msgs__msg__Observation__Sequence *
robot_calibration_msgs__msg__Observation__Sequence__create(size_t size)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  robot_calibration_msgs__msg__Observation__Sequence * array = (robot_calibration_msgs__msg__Observation__Sequence *)allocator.allocate(sizeof(robot_calibration_msgs__msg__Observation__Sequence), allocator.state);
  if (!array) {
    return NULL;
  }
  bool success = robot_calibration_msgs__msg__Observation__Sequence__init(array, size);
  if (!success) {
    allocator.deallocate(array, allocator.state);
    return NULL;
  }
  return array;
}

void
robot_calibration_msgs__msg__Observation__Sequence__destroy(robot_calibration_msgs__msg__Observation__Sequence * array)
{
  rcutils_allocator_t allocator = rcutils_get_default_allocator();
  if (array) {
    robot_calibration_msgs__msg__Observation__Sequence__fini(array);
  }
  allocator.deallocate(array, allocator.state);
}

bool
robot_calibration_msgs__msg__Observation__Sequence__are_equal(const robot_calibration_msgs__msg__Observation__Sequence * lhs, const robot_calibration_msgs__msg__Observation__Sequence * rhs)
{
  if (!lhs || !rhs) {
    return false;
  }
  if (lhs->size != rhs->size) {
    return false;
  }
  for (size_t i = 0; i < lhs->size; ++i) {
    if (!robot_calibration_msgs__msg__Observation__are_equal(&(lhs->data[i]), &(rhs->data[i]))) {
      return false;
    }
  }
  return true;
}

bool
robot_calibration_msgs__msg__Observation__Sequence__copy(
  const robot_calibration_msgs__msg__Observation__Sequence * input,
  robot_calibration_msgs__msg__Observation__Sequence * output)
{
  if (!input || !output) {
    return false;
  }
  if (output->capacity < input->size) {
    const size_t allocation_size =
      input->size * sizeof(robot_calibration_msgs__msg__Observation);
    rcutils_allocator_t allocator = rcutils_get_default_allocator();
    robot_calibration_msgs__msg__Observation * data =
      (robot_calibration_msgs__msg__Observation *)allocator.reallocate(
      output->data, allocation_size, allocator.state);
    if (!data) {
      return false;
    }
    // If reallocation succeeded, memory may or may not have been moved
    // to fulfill the allocation request, invalidating output->data.
    output->data = data;
    for (size_t i = output->capacity; i < input->size; ++i) {
      if (!robot_calibration_msgs__msg__Observation__init(&output->data[i])) {
        // If initialization of any new item fails, roll back
        // all previously initialized items. Existing items
        // in output are to be left unmodified.
        for (; i-- > output->capacity; ) {
          robot_calibration_msgs__msg__Observation__fini(&output->data[i]);
        }
        return false;
      }
    }
    output->capacity = input->size;
  }
  output->size = input->size;
  for (size_t i = 0; i < input->size; ++i) {
    if (!robot_calibration_msgs__msg__Observation__copy(
        &(input->data[i]), &(output->data[i])))
    {
      return false;
    }
  }
  return true;
}
